// bure.h - Klasa buradi.

#ifndef _bure_h_
#define _bure_h_

#include "teret.h"
#include <utility>
using std::move;

class Bure: public Teret {
  double r, h;                               // Poluprečnik i visina valjka.
public:
  explicit Bure(double sigma=1, double r=1, double h=1) // Inicijalizacija.
    : Teret{sigma}, r{r}, h{h} {}
  char vrsta() const override { return 'B'; }// Oznaka vrste tereta.
  double zapr() const override               // Zapremina bureta.
    { return r * r * 3.14159 * h; }
  Bure* kopija() const& override             // Kopija bureta kopiranjem.
    { return new Bure(*this); }
  Bure* kopija() && override                 // Kopija bureta premeštanjem.
    { return new Bure(move(*this)); }
};

#endif
