// ciklus.h - Klasa ciklusa.

#ifndef _ciklus_h_
#define _ciklus_h_

#include "izraz.h"
using Izrazi::Izraz;
#include "naredba.h"

namespace Naredbe {
  class Ciklus: public Naredba {
    Izraz*   usl;                            // Uslov ciklusa.
    Naredba* nar;                            // Sadržaj ciklusa.
    void kopiraj(const Ciklus& c)            // Kopiranje u ciklus.
      { usl = c.usl->kopija(); nar = c.nar->kopija(); }
    void brisi() { delete usl; delete nar; } // Oslobađanje memorije.
    void pisi(ostream& it) const {           // Pisanje.
      Naredba::pisi(it); it << "while(" << *usl << ")\n";
      nivo++; it << *nar; nivo--;
    }
  public:
    Ciklus(const Izraz& u, const Naredba& n)  // Inicijalizacija.
      : usl{u.kopija()}, nar{n.kopija()} {}
    Ciklus(const Ciklus& s) { kopiraj(s); }   // Kopirajući konstruktor.
    ~Ciklus() { brisi(); }                 // Uništavanje ciklusa.
    Ciklus& operator=(const Ciklus& s) {   // Kopirajuća dodela vrednosti.
      if (this != &s) { brisi(); kopiraj(s); }
      return *this;
    }
    void izvrsi() const                                  // Izvršavanje.
    { while (usl->vredn()) nar->izvrsi(); }
    Ciklus* kopija() const { return new Ciklus(*this); } // Kopija.
  }; // class Ciklus
} // namespace Naredbe

#endif
