// crtez2.h - Klasa crteža.

#ifndef _crtez2_h_
#define _crtez2_h_

#include "figura4.h"
#include "niz7.h"
#include <utility>
using std::move;

class Crtez: public Figura {
  Niz<Figura> niz;                                       // Niz figura.
  void pisi(ostream& it) const override { it << niz; }   // Pisanje crteža.
public:
  explicit Crtez(int kap): niz{kap} {}    // Stvaranje praznog crteža.
  Crtez& operator+=(const Figura& f)      // Dodavanje figure kopiranjem.
    { niz += f; return *this;}
  Crtez& operator+=(Figura&& f)           // Dodavanje figure premeštanjem.
    { niz += move(f); return *this;}
  Crtez& operator+=(const Vektor& v);     // Pomeranje crteža.
  Crtez* kopija() const& override         // Kopija crteža kopiranjem.
    { return new Crtez(*this); }
  Crtez* kopija() && override             // Kopija crteža premeštanjem.
    { return new Crtez(move(*this)); }
};

inline Crtez& Crtez::operator+=(const Vektor& v) { // Pomeranje crteža.
  for (int i=0; i<niz.kapac(); i++)
    try { niz[i] += v; } catch (G_prazno) {}
  return *this;
}

#endif
