// datum1.h - Definicija klase kalendarskih datuma.

#include <cstdlib>
#include <string>
using std::string;

class Datum {
  static const short duz[][12];  // Brojevi dana po mesecima.
  static const short prot[][12]; // Protekli dani od početka godine.
  static const string ime_d[];   // Imena dana.
  static const string ime_m[];   // Imena meseci.
  short dan, mes, god;           // Delovi datuma.
public:
  static bool prestupna(short g);              // Da li je prestupna godina?
  bool prestupna() const { return prestupna(god); }
  static bool moze(short d, short m, short g); // Da li je ispravan?
  Datum(short d, short m, short g);            // Stvaranje datuma.
  short dohv_dan() const { return dan; }       // Dohvatanje delova datuma.
  short dohv_mes() const { return mes; }
  short dohv_god() const { return god; }
  static Datum citaj();                        // Čitanje datuma.
  void pisi() const;                           // Pisanje datuma.
  int  dan_u_god() const;                      // Redni broj dana u godini.
  long uk_dan() const;                         // Redni broj dana od 1.1.1.
  int  dan_u_ned() const;                      // Redni broj dana u nedelji.
  int  duz_mes() const;                        // Broj dana u mesecu.
  void sutra();                                // Sledeći datum.
  void juce();                                 // Prethodni datum.
  void dodaj (unsigned k);                     // Dodavanje celog broja.
  void oduzmi(unsigned k);                     // Oduzimanje celog broja.
  friend long razlika(const Datum& dat1,       // Razlika dva datuma.
                      const Datum& dat2);
  string ime_dan() const;                      // Ime dana.
  string ime_mes() const;                      // Ime meseca.
};
 
// Definicije ugrađenih metoda i funkcija.

inline bool Datum::prestupna(short g)
  { return g%4==0 && g%100!=0 || g%400==0; }

inline bool Datum::moze(short d, short m, short g)
  { return g>0 && m>0 && m<=12 && d>0 && d<=duz[prestupna(g)][m-1]; }

inline Datum::Datum(short d, short m, short g)
  : dan(d), mes(m), god(g) {
  if (!moze(d, m, g)) exit(1);
  
}

inline int Datum::dan_u_god() const
  { return prot[prestupna()][mes-1] + dan; }

inline int Datum::dan_u_ned() const { return(uk_dan() + 6) % 7 + 1; }

inline int Datum::duz_mes() const { return duz[prestupna()][mes-1]; }

inline long razlika(const Datum& dat1, const Datum& dat2)
  { return dat1.uk_dan() - dat2.uk_dan(); }

inline string Datum::ime_mes() const { return ime_m[mes-1]; }

inline string Datum::ime_dan() const { return ime_d[dan_u_ned()-1]; }
