// datum2.h - Definicija klase kalendarskih datuma.

#include <iostream>
using std::cin, std::cout;

class Datum {
  int d, m, g;                            // Dan, mesec i godina.
  static const inline int dani[2][12] = { // Brojevi dana po mesecima.
    {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
    {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}
  };
public:
  static bool moze(int d, int m, int g)   // Da li je ispravan?
    { return g>0 && m>0 && m<=12 && d>0 && d<=dani[g%4==0][m-1]; }
  explicit Datum(int d=1, int m=7, int g=2020)  // Stvaranje datuma.
    : d(d), m(m), g(g)
    { if (!moze(d, m, g)) exit(1); }
  int dan() const { return d; }           // Dohvatanje delova datuma.
  int mes() const { return m; }
  int god() const { return g; }
  int uporedi(const Datum& dat) const {   // Upoređivanje datuma.
    if (g != dat.g) return g - dat.g;
    if (m != dat.m) return m - dat.m;
                    return d - dat.d;
  }
  bool citaj() {                          // Čitanje datuma.
    int d, m, g; cin >> d >> m >> g;
    if (!moze(d, m, g)) return false;
    *this = Datum(d, m, g); return true;
  }
  void pisi() const                       // Pisanje datuma.
    { cout << d << '.' << m << '.' << g << '.'; }
};
