// figura1_t.cpp - Ispitivanje klasa geometrijskih figura.

#include "krug2.h"
#include "kvadrat.h"
#include "trougao4.h"
#include <iostream>
using std::cin, std::cout, std::endl;

int main() {

  // Element liste figura.
  struct Elem {
    Figura* fig; Elem* sled;
    Elem(Figura* f, Elem* s=nullptr): fig{f}, sled{s} {}
    ~Elem() { delete fig; }
  };

  // Stvaranje liste figura čitajući sa standardnog ulaza.
  Elem *prvi = nullptr, *posl = nullptr;
  while (true) {
    Figura* pf = nullptr;
    char vrsta; cin >> vrsta;
    switch (vrsta) {
      case 'o': pf = new Krug;    break;
      case 'k': pf = new Kvadrat; break;
      case 't': pf = new Trougao; break;
    }
  if (!pf) break;
    cin >> *pf;
    Elem* novi = new Elem(pf);
    posl = (!prvi ? prvi : posl->sled) = novi;
  }

  // Prikazivanje sadržaja liste na standardnom izlazu.
  for (Elem* tek=prvi; tek; tek=tek->sled) cout << *tek->fig << endl;

  // Čitanje pomeraja za pomeranje figura.
  Real dx, dy; cin >> dx >> dy;
               cout << "\ndx, dy= " << dx << ", " << dy << "\n\n";

  // Stvaranje kopije liste uz pomeranje figura.
  Elem *poc = nullptr, *kraj = nullptr;
  for (Elem* tek=prvi; tek; tek=tek->sled) {
    Elem* novi = new Elem(tek->fig->kopija());
    novi->fig->pomeri(dx,dy);
    kraj = (!poc ? poc : kraj->sled) = novi;
  }

  // Uništavanje prve liste.
  while (prvi) { Elem* stari=prvi; prvi=prvi->sled; delete stari; }
  posl = nullptr;

  // Prikazivanje sadržaja kopirane liste na standardnom izlazu.
  for (Elem* tek=poc; tek; tek=tek->sled) cout << *tek->fig << endl;

  // Uništavanje druge liste.
  while (poc) { Elem* stari=prvi; prvi=prvi->sled; delete stari; }
  kraj = nullptr;
}
