// grafik_t.cpp - Ispitivanje funkcije grafik.

#include "funkcija.h"
#include "poli3.h"
#include <cmath>
#include <iostream>
using std::exp, std::sin, std::cout, std::endl;

void grafik(double (*)(double), double, double, int,
                                double, double, int);

int main() {
  // Funkcija je zadata globalnom funkcijom.
  grafik(sin, 0, 20, 61, -1, 1, 11);
  cout << endl;

  // Funkcija je zadata statičkom metodom.
  grafik(Funkcija::f, 0.001, 20, 61, -0.2, 1, 13);
  cout << endl;

  // Funkcija je zadata lambda izrazom.
  grafik([](double x){ return exp(-0.1*x)*sin(x); }, 0, 20, 61, -1, 1, 11);
  cout << endl;

  // Funkcija je zadata objektom pomoću lambda izraza.
  double a[] = {4,-4,-1,1};
  int n = sizeof(a) / sizeof(double) - 1;
  static Poli p{a, n}; // (x+2)(x-1)(x-2)
  grafik([](double x){ return p(x); }, -3, 3, 61, -3, 7, 11);
}
