// imenik1.h - Definicija klase imenika.

#include "osoba1.h"

class Imenik {
  struct Elem {                           // Element liste:
    Osoba oso;                            // - sadržana osoba,
    Elem* sled;                           // - pokazivač na sledeći element,
    Elem(const Osoba& o, Elem* s=nullptr) // - konstruktor.
      : oso(o), sled(s) {}
  };
  Elem* prvi;                             // Pokazivač na početak liste.
public:
  Imenik(): prvi(nullptr) {}              // Stvaranje praznog imenika.
  Imenik(const Imenik& im);               // Kopirajući konstruktor.
  Imenik(Imenik&& im)                     // Premeštajući konstruktor.
    { prvi = im.prvi; im.prvi = nullptr; }
  ~Imenik();                              // Destruktor.
  Imenik& dodaj(const Osoba& oso);        // Dodavanje osobe.
  void pisi() const;                      // Pisanje imenika.
};
