// izvor.h - Klasa izvora električne energije.

#ifndef _izvor_h_
#define _izvor_h_

#include "potrosac1.h"
#include <iostream>
using std::ostream, std::endl;
 
namespace Potrosaci {
  class G_indeks{};                // KLASA GREŠAKA: Indeks izvan opsega.
  inline ostream& operator<<(ostream& it, const G_indeks&)
    { return it << "*** Nedozvoljen indeks! ***"; }

  class G_preopt {};               // KLASA GREŠAKA: Preopterećen izvor.
  inline ostream& operator<<(ostream& it, const G_preopt&)
    { return it << "*** Preopterecen izvor! ***"; }

  class Izvor {                                 // KLASA IZVORA:
    Potrosac** niz;                             // Niz potrošača. 
    int kap;                                    // Broj priključnih mesta.
    double sna, opt;               // Nazivna snaga i trenutno opterećenje.
  public:
    Izvor(double s, int k);                     // Stvaranje izvora.
    Izvor(const Izvor&) =delete;                // Ne sme da se kopira.
    Izvor& operator=(const Izvor&) =delete;     // Ne sme da se dodeljuje.
    ~Izvor();                                   // Uništavanje izvora.
    double snaga() const { return sna; }        // Nazivna snaga izvora.
    double opterecenje() const { return opt; }  // Trenutno opterećenje.
    int brMesta() const { return kap; }         // Broj priključnih mesta.
    Izvor& prikljuci(Potrosac* p, int i);       // Priključivanje potrošača.
    friend ostream& operator<<(ostream& it, const Izvor& izv); // Pisanje.
  }; // class Izvor
} // namespace Potrosaci

#endif
