// krug1.h - Definicija klase krugova
//           u ravni.

#include "tacka2.h"
#include <cstdlib>
#include <cmath>
#include <iostream>
using std::cout, std::endl;

class Krug {
  Tacka c; double r;          // Centar i poluprečnik kruga.
  Krug *pret, *sled;          // Pokazivači na prethodni i na sledeći krug.
  static inline Krug* prvi=nullptr;// Početak zajedničke liste svih krugova.
  Krug() { r = -1; }          // Stvaranje "praznog" kruga:
                              //   - SAMO za interne potrebe!
  Krug(const Krug&) =delete;  // Kopirajući konstruktor:
                              //   - NE SME da se pravi kopija!
public:
  static bool moze(double r, double x, double y); // Može li postojati?
  Krug(double rr, double x, double y);            // Stvaranje kruga.
  ~Krug();                                        // Uništavanje kruga.
  friend double rastojanje(const Krug& k1,        // Rastojanje dva kruga.
                           const Krug& k2);
  bool premesti(double  x, double  y);            // Premeštanje kruga.
  bool pomeri  (double dx, double dy);            // Pomeranje kruga.
  void pisi() const;                              // Pisanje kruga.
  static void pisiSve();                          // Pisanje svih krugova.
};

// Definicije ugrađenih funkcija i metoda izvan klase.

inline double rastojanje(const Krug& k1, const Krug& k2)
  { return k1.c.rastojanje(k2.c) - k1.r - k2.r; } // Rastojanje dva kruga.

inline void Krug::pisi() const                    // Pisanje kruga.
  { cout << "K[" << r << ','; c.pisi(); cout << ']'; }
