// krug3.h - Klasa obojenih krugova u ravni.

#ifndef _krug3_h_
#define _krug3_h_

#include "figura3.h"
#include <utility>
using std::move;

namespace Figure {
  class Krug: public Figura {
    Tacka  C;                                  // Centar.
    double r;                                  // Poluprečnik.
  public:                                      // Konstruktor.
    explicit Krug(Tacka C=Tacka(), double r=1, Boja b=Boja{})
      : Figura{b}, C{C}, r{r} {}
    Krug* kopija() const& override             // Kopija kruga kopiranjem.
      { return new Krug(*this); }
    Krug* kopija() && override                 // Kopija kruga premeštanjem.
      { return new Krug(move(*this)); }
    bool pripada(const Tacka& T) const         // Da li tačka pripada?
      { return C.rastojanje(T) <= r; }
  }; // class Krug
} // namespace Figure

#endif
