// lista2.cpp - Definicije metoda listi celih brojeva (iterativno).

#include "lista2.h"
#include <iostream>
using std::cin, std::cout;

int Lista::duz() const {          // Broj elemenata liste.
  int n = 0;
  for (Elem* tek=prvi; tek; tek=tek->sled)
    n++;
  return n;
}

void Lista::pisi() const {        // Pisanje liste.
  for (Elem* tek=prvi; tek; tek=tek->sled)
    cout << tek->broj << ' ';
}

void Lista::na_kraj(int b) {      // Dodavanje na kraj.
  Elem* novi = new Elem(b);
  if (!prvi) prvi = novi;
  else {
    Elem* tek = prvi;
    while (tek->sled) tek = tek->sled;
    tek->sled = novi;
  }
}

void Lista::citaj1(int n) { // Čitanje stavljajući brojeve na početak.
  prazni();
  for (int i=0; i<n; i++) {
    int b; cin >> b;
    prvi = new Elem(b, prvi);
  }
}

void Lista::citaj2(int n) { // Čitanje stavljajući brojeve na kraj.
  prazni(); Elem* posl = nullptr;
  for (int i=0; i<n; i++) {
    int b; cin >> b;
    Elem* novi = new Elem(b);
    if (!prvi) prvi = novi; else posl->sled = novi;
    posl = novi;
  }
}

Lista::Lista(const Lista& lst) {  // Kopirajući konstruktor.
  prvi = nullptr; 
  for (Elem *tek=lst.prvi, *posl=nullptr; tek; tek=tek->sled) {
    Elem* novi = new Elem(tek->broj);
    if (!prvi) prvi = novi; else posl->sled = novi;
    posl = novi;
  }
}
 
void Lista::umetni(int b) {       // Umetanje u uređenu listu.
  Elem *tek=prvi, *pret=nullptr;
  while (tek && tek->broj < b)
    { pret = tek; tek = tek->sled; }
  Elem* novi = new Elem(b, tek);
  if (!pret) prvi = novi;
    else pret->sled = novi;
}


void Lista::prazni() {            // Pražnjenje liste.
  while (prvi) {
    Elem* stari = prvi;
    prvi = prvi->sled;
    delete stari;
  }
}

void Lista::izostavi(int b) {     // Izostavljanje svakog pojavljivanja.
  Elem *tek = prvi, *pret = nullptr;
  while (tek)
    if (tek->broj != b) {
      pret = tek; tek = tek->sled;
    } else {
      Elem* stari = tek;
      tek = tek->sled;
      if (!pret) prvi = tek;
        else pret->sled = tek;
      delete stari;
    }
}
