// lista2.h - Definicija klase listi celih brojeva (iterativno).

class Lista {
  struct Elem {                  // ELEMENT LISTE:
    int broj;                    // - sadržaj,
    Elem* sled;                  // - pokazivač na sledeći element,
    Elem(int b, Elem* s=nullptr) // - konstruktor.
      : broj(b), sled(s) {}
  };
  Elem* prvi;                    // Pokazivač na početak liste.
public:                          // Konstruktori:
  Lista(): prvi(nullptr) {}      // - podrazumevani,
  Lista(int b)                   // - konvertujući,
    : prvi(new Elem(b)) {}
  Lista(const Lista& lst);       // - kopirajući,
  Lista(Lista&& lst)             // - premeštajući.
    { prvi = lst.prvi; lst.prvi = nullptr; }
  ~Lista() { prazni(); }         // Destruktor.
  int duz() const;               // Broj elemenata liste.
  void pisi() const;             // Pisanje liste.
  void na_pocetak(int b) {       // Dodavanje na
    prvi = new Elem(b, prvi);    //   početak.
  }
  void na_kraj(int b);     // Dodavanje na kraj.
  void citaj1(int n);      // Čitanje liste stavljajući brojeve na početak.
  void citaj2(int n);      // Čitanje liste stavljajući brojeve na kraj.
  void umetni(int b);      // Umetanje u uređenu listu.
  void prazni();           // Pražnjenje liste.
  void izostavi(int b);    // Izostavljanje svakog pojavljivanja.
};
