// lista_dat.h - Definicija klase listi datuma.

#include "datum2.h"

class Lista {
  struct Elem {                    // ELEMENT LISTE:
    Datum dat;                     // - sadržani datum,
    Elem* sled;                    // - pokazivač na sledeći element,
    Elem(const Datum& d)           // - konstruktor.
      : dat(d), sled(nullptr) {}
  };
  Elem *prvi, *posl;               // Pokazivač na početak i kraj liste.
  int duz;                         // Dužina liste.
public:                                            // Konstruktori:
  Lista(): prvi(nullptr), posl(nullptr), duz(0) {} // - podrazumevani,
  Lista(const Lista& lst);                         // - kopirajući,
  Lista(Lista&& lst) {                             // - premeštajući.
    prvi = lst.prvi; posl = lst.posl;
    duz = lst.duz; lst.prvi = lst.posl = nullptr; }
  ~Lista();                                        // Destruktor.
  Lista& dodaj(const Datum& dat) {                 // Dodavanje datuma.
    posl = (!prvi ? prvi : posl->sled) = new Elem(dat);
    duz++;
    return *this;
  }
  int duzina() const { return duz; }     // Dužina liste.
  const Datum* max() const;              // Najkasniji (svežiji) datum.
  void pisi() const;                     // Pisanje  liste.
};
