// lokomot1.h - Klasa lokomotiva.

#ifndef _lokomot1_h_
#define _lokomot1_h_

#include "vozilo2.h"
#include <utility>
using std::move;

namespace Vozovi {
  class Lokomot: public Vozilo {
    float v_sila;                         // Vučna sila lokomotive.
    void pisi(ostream& it) const override // Pisanje lokomotive.
      { Vozilo::pisi(it); it << '(' << v_sila << ')'; }
  public:
    static const char VR{'L'};            // Oznaka za lokomotive.
    Lokomot(float sop_tez, float v_sila)  // Konstruktor.
      : Vozilo(sop_tez), v_sila{v_sila} {}
    char vrsta() const override { return VR; }           // Oznaka vrste.
    float uk_tezina() const override                     // Ukupna težina.
      { return sop_tezina(); }
    float vucna_sila() const { return v_sila; }         // Vučna sila.
    Lokomot* kopija() const& override     // Kopija lokomotive kopiranjem.
      {return new Lokomot(*this);}
    Lokomot* kopija() && override         // Kopija lokomotive premeštanjem.
      {return new Lokomot(move(*this));}
  }; // class Lokomot
} // namespace Vozovi

#endif
