// mat_tacka.h - Definicija klase materijalnih tačaka.

#include <iostream>
#include <cmath>
using std::sqrt, std::pow, std::cout;

class Mat_tacka {
  double m, x, y, z;                           // Masa i koordinate tačke.
public:
  explicit Mat_tacka(double m=1, double x=0,   // Stvaranje tačke.
                     double y=0, double z=0)
    : m(m), x(x), y(y), z(z) {}
  double r(const Mat_tacka& mt) const          // Rastojanje do tačke.
    { return sqrt(pow(x-mt.x,2) + pow(y-mt.y,2) + pow(z-mt.z,2)); }
  double F(const Mat_tacka& mt) const          // Privlačna sila.
    { return 6.67e-11 * m * mt.m / pow(r(mt),2); }
  void pisi() const                            // Pisanje tačke.
    { cout << '[' << m << ",(" << x << ',' << y << ',' << z <<")]"; }
};
