// mnogougao1.h - Klasa mnogouglova u prostoru.

#ifndef _mnogougao1_h_
#define _mnogougao1_h_

#include "figura2.h"
#include "vektor3.h"
#include <iostream>
using std::ostream;

class G_indeks {}; // Klasa grešaka: Nedozvoljen indeks.
inline ostream& operator<<(ostream& it, const G_indeks&)
  { return it << "*** Nedozvoljen indeks! ***"; }
class Mnogougao: public Figura {
  Vektor* niz;                                  // Temena mnogougla.
  int     n;                                    // Broj temena.
  void pisi(ostream& it) const;                 // Pisanje mnogougla.
  void kopiraj(const Mnogougao& m);             // Kopiranje u mnogougao.
  void premesti(Mnogougao& m)                   // Premeštanje u mnogougao.
    { niz = m.niz; n = m.n; m.niz = nullptr; }
  void brisi() { delete [] niz; }               // Oslobađanje memorije.
public:
  explicit Mnogougao(int n=3)                   // Stvaranje mnogougla.
    : niz{new Vektor[n]}, n{n} {}
  Mnogougao(const Mnogougao& m) { kopiraj(m); } // Kopirajući konstruktor.
  Mnogougao(Mnogougao&& m) { premesti(m); }     // Premeštajući konstruktor.
  ~Mnogougao() { delete [] niz; }               // Uništavanje mnogougla.
  Mnogougao& operator=(const Mnogougao& m) {    // Kopirajuća dodela
    if (this != &m) { brisi(); kopiraj(m); }    //   vrednosti.
    return *this;
  }
  Mnogougao& operator=(Mnogougao&& m) {         // Premeštajuća dodela
    if (this != &m) { brisi(); premesti(m); }   //   vrednosti.
    return *this;
  }
  Mnogougao* kopija() const                     // Kopija mnogougla
    { return new Mnogougao(*this); }
  Mnogougao& operator+=(const Vektor& v);       // Pomeranje mnogougla.
  Vektor teziste() const;                       // Težište.
  Vektor& operator[](int i) {                   // Pristupanje temenu:
    if (i<0 || i>=n) throw G_indeks();          // - promenljivog
    return niz[i];                              //   mnogougla,
  }
  const Vektor& operator[](int i) const {       // - nepromenljivog objekta.
    if (i<0 || i>=n) throw G_indeks();          //   mnogougla.
    return niz[i];
  }
};

#endif
