// niz1.h - Klasa nizova realnih brojeva.

#ifndef _niz1_h_
#define _niz1_h_

class Niz {
  double* a; int n;                           // Niz i dužina niza.
  void kopiraj(const Niz& niz) {              // Kopiranje u niz.
    a = new double [n = niz.n];
    for (int i=0; i<n; i++) a[i] = niz.a[i];
  }
  void premesti(Niz& niz)                     // Premeštanje u niz.
    { a = niz.a; n = niz.n; niz.a = nullptr; }
  void brisi() { delete [] a; }               // Oslobađanje memorije.
public:
  explicit Niz(int n=10): a{new double[n]}, n{n} {} // Stvaranje niza.
  Niz(const Niz& niz) { kopiraj(niz); }       // Inicijalizacija nizom.
  Niz(Niz&& niz) { premesti(niz); }
  ~Niz() { delete [] a; }                     // Uništavanje.
  Niz& operator=(const Niz& niz) {            // Dodela vrednosti.
    if (this != &niz) { brisi(); kopiraj(niz); }
    return *this;
  }
  Niz& operator=(Niz&& niz) {
    if (this != &niz) { brisi(); premesti(niz); }
    return *this;
  }
  double& operator[](int i) {                 // Pristup elementu
    if (i<0 || i>=n) throw i;                 // - promenljivog niza,
    return a[i];
  }
  const double& operator[](int i) const {     // - nepromenljivog niza.
    if (i<0 || i>=n) throw i;
    return a[i];
  }
  int duz() const { return n; }               // Dužina niza.
};

#endif
