// niz_kompl.h - Klasa nizova kompleksnih brojeva.

#include "kompl1.h"

class Niz_kompl {
  int n; Kompl* niz;                    // Dužina i pokazivač na elemente.
  void kopiraj(const Niz_kompl& nk) {          // Kopiranje u niz.
    niz = new Kompl [n = nk.n];
    for (int i=0; i<n; i++) niz[i] = nk.niz[i];
  }
  void premesti(Niz_kompl& nk) {               // Premeštanje u niz.
    niz = nk.niz; nk.niz = nullptr;
    n = nk.n;
  }
  void brisi() { delete [] niz; }              // Oslobađanje memorije.
public:                                        // Konstruktori:
  explicit Niz_kompl(int n=10)                 // - podrazumevani,
    : n(n), niz(new Kompl [n]) {}
  Niz_kompl(const Niz_kompl& nk)               // - kopirajući,
    { kopiraj(nk); }
  Niz_kompl(Niz_kompl&& nk) { premesti(nk); }  // - premeštajući.
  ~Niz_kompl() { brisi(); }                    // Destruktor.
                                               // Dodela vrednosti:
  Niz_kompl& operator=(const Niz_kompl& nk) {  // - kopirajuća,
    if (this != &nk) { brisi(); kopiraj(nk); }
    return *this;
  }
  Niz_kompl& operator=(Niz_kompl&& nk) {       // - premeštajuća.
    if (this != &nk) { brisi(); premesti(nk); }
    return *this;
  }
  int duz() const { return n; }                // Dužina niza.
                                               // Element niza:
  Kompl& operator[](int i)                     // - promenljivog,
    { return niz[i]; }
  const Kompl& operator[](int i) const         // - nepromenljivog.
    { return niz[i]; }
};
