// otpornik.h – Klasa otpornika.

#include <iostream>
using std::istream, std::ostream;

class Otpornik {
  double r, dr;              // Otpornost i korak promene.
public:
  Otpornik(double r=1000, double dr=1) // Stvaranje objekta.
    : r{r}, dr{dr} {}
  double otp() const { return r; }     // Dohvatanje otpornosti.
  Otpornik& operator++()               // Povećanje otpornosti.
    { r += dr; return *this; }
  Otpornik& operator--() {             // Smanjivanje otpornosti.
    r -= dr; if (r < 0) r = 0;
    return *this;
  }
  friend istream& operator>>(istream& ut, Otpornik& r)       // Čitanje.
    { return ut >> r.r >> r.dr; }
  friend ostream& operator<<(ostream& it, const Otpornik& r) // Pisanje.
    { return it << "R(" << r.r << ',' << r.dr << ')'; }
};
