// polica.cpp - Metode i funkcije uz klasu polica za knjige.

#include "polica.h"

Polica::Polica(int br_mesta)                     // Inicijalizacija.
    : knjige{new const Knjiga*[br_mesta]},
      br_mesta(br_mesta), br_knjiga{0} {
  for (int i=0; i<br_mesta; knjige[i++] = nullptr);
}

bool Polica::operator+=(const Knjiga* k) {       // Stavljanje knjige.
  if (br_knjiga == br_mesta) return false;
  int i = 0; while (knjige[i]) i++;
  knjige[i] = k;
  return true;
}

const Knjiga* Polica::operator-=(int poz) {      // Uzimanje knjige.
  if (poz<0 || poz>=br_mesta || !knjige[poz]) return nullptr;
  const Knjiga* k = knjige[poz];
  knjige[poz] = nullptr;
  br_knjiga--;
  return k;
}

double Polica::uk_vrednost() const {             // Ukupna vrednost knjiga.
  double uv = 0;
  for (int i=0; i<br_mesta; i++)
    if (knjige[i]) uv += knjige[i]->vrednost();
  return uv;
}

ostream& operator<<(ostream& it, const Polica& p) { // Pisanje u tok.
  for (int i=0; i<p.br_mesta; i++)
    if (p.knjige[i]) {
      p.knjige[i]->pisi(it);
      it << endl;
    }
  it << "=================================\n";
  it << "Ukupna vrednost: " << p.uk_vrednost() << std::endl;
  return it;
}
