// proizvodjac.h - Generička klasa proizvođača.

#ifndef _proizvodjac_h_
#define _proizvodjac_h_

#include "akter.h"
#include "skladiste.h"
using std::cout, std::endl;

template <typename T>
class Proizvodjac: public Akter {
  Skladiste<T>* sklad;                           // Odredišno skladište.
public:
  Proizvodjac(Skladiste<T>* sklad,               // Inicijalizacija.
              double t_min=0, double t_max=1)
    : Akter{t_min, t_max}, sklad{sklad} {}
  void radnja() override {                       // Radnja proizvođača.
    cout << *this << ": ";
    try {
      T t = T();
      sklad->stavi(t);
      cout << "stavio " << t << endl;
    } catch (G_puno g) { cout << g << endl; }
  }
};

#endif
