// recnik1.cpp - Metode i funkcije uz klasu rečnika.

#include "recnik1.h"

void Recnik::kopiraj(const Recnik& rec) {      // Kopiranje u objekat.
  prvi = nullptr;
  for (Elem *tek=rec.prvi, *posl=nullptr; tek; tek=tek->sled)
    posl = (!prvi ? prvi : posl->sled) = new Elem(tek->odr);
}

void Recnik::brisi() {                         // Oslobađanje memorije.
  while (prvi) { Elem* stari = prvi; prvi = prvi->sled; delete stari; }
}

Recnik& Recnik::operator+=(const Odred& odr) { // Dodavanje odrednice.
  Elem *tek = prvi, *pret = nullptr;
  while (tek && tek->odr<odr) { pret = tek; tek = tek->sled; }
  (!pret ? prvi : pret->sled) =  new Elem(odr, tek);
  return *this;
}
 
Recnik Recnik::operator<<(string poj) {        // Svi prevodi pojma.
  Recnik rec;
  for (Elem* tek=prvi; tek; tek=tek->sled)
    if (tek->odr == poj) rec += tek->odr;
  return rec;
}

ostream& operator<<(ostream& it, const Recnik& rec) { // Pisanje.
  for (Recnik::Elem* tek=rec.prvi; tek; tek=tek->sled)
    it << tek->odr << endl;
  return it;
}
