// recnik1.h - Klasa rečnika.

#include "odred.h"
#include <iostream>
using std::string, std::ostream, std::endl;

class Recnik {
  struct Elem {                                // Element liste.
    Odred odr; Elem* sled;
    Elem(const Odred& odr ,Elem* s=nullptr): odr{odr}, sled{s} {}
  };
  Elem* prvi;                                  // Početak liste.
  void kopiraj(const Recnik& rec);             // Kopiranje u objekat.
  void premesti(Recnik& rec)                   // Premeštanje u objekat.
    { prvi = rec.prvi; rec.prvi = nullptr;}
  void brisi();                                // Oslobađanje memorije.
public:
  Recnik(): prvi{nullptr} {}                   // Stvaranje praznog rečnika.
  Recnik(const Recnik& rec) {kopiraj(rec);}    // Kopirajući konstruktor.
  Recnik(Recnik&& rec) { premesti(rec); }      // Premeštajući konstruktor.
  ~Recnik() { brisi(); }                       // Destruktor.
  Recnik& operator=(const Recnik& rec) {       // Kopirajuća dodela
    if (this != &rec) {brisi(); kopiraj(rec);} //   vrednosti.
    return *this;
  }
  Recnik& operator=(Recnik&& rec) {            // Premeštajuća dodela
    if (this != &rec) {brisi(); premesti(rec);}//   vrednosti.
    return *this;
  }
  Recnik& operator+=(const Odred& odr);        // Dodavanje odrednice.
  Recnik operator<<(string poj);               // Svi prevodi pojma.
  friend ostream& operator<<(ostream& it, const Recnik& rec); // Pisanje.
};
