// recnik2.h - Klasa rečnika.

#ifndef _recnik2_h_
#define _recnik2_h_

#include <string>
#include <set>
#include <map>
#include <iostream>
using std::string, std::set, std::map, std::ostream, std::endl;

class Recnik {
  map<string,set<string> > niz;         // Sadržaj rečnika.
public:
  // Dodavanje prevoda reči.
  Recnik& dodaj(const string& rec, const string& prevod) {
    niz[rec].insert(prevod);
    return *this;
  }
  
  // Brisanje svih prevoda reči.
  Recnik& brisi(const string& rec) {
    niz.erase(rec);
    return *this;
  }
  
  // Brisanje jednog prevoda reči.
  Recnik& brisi(const string& rec, const string& prevod) {
    map<string,set<string> >::iterator i = niz.find(rec);
    if (i != niz.end()) i->second.erase(prevod);
    return *this;
  }
  
  // Dohvatanje svih prevoda reči.
  const set<string>* prevodi(const string& rec) const {
    map<string,set<string> >::const_iterator i = niz.find(rec);
    if (i != niz.end()) return &i->second;
      else              return nullptr;
  }
  
  // Pisanje svih prevoda reči.
  void pisiPrevode(ostream& it, const string& rec) const;
 
  // Pisanje sadržaja rečnika.
  friend ostream& operator<<(ostream& it, const Recnik& recnik);
};

#endif
