// tacka3.h – Klasa tačaka u ravni.

#include <cmath>
#include <iostream>
using std::ostream;

class Tacka {
  double x, y;                             // Koordinate tačke.
public:
  explicit Tacka(double x=0, double y=0)   // Stvaranje tačke.
    : x{x}, y{y} {}
  double dohv_x() const { return x; }      // Dohvatanje koordinata.
  double dohv_y() const { return y; }
  bool operator==(const Tacka& T2) const   // Da li se poklapaju?
    { return x==T2.x && y==T2.y; }
  bool operator!=(const Tacka& T2) const   // Da li se ne poklapaju?
    { return x!=T2.x || y!=T2.y; }
  double operator-(const Tacka& T2) const  // Rastojanje dve tačke.
    { return sqrt(pow(x-T2.x, 2) + pow(y-T2.y, 2)); }
  friend ostream& operator<<(ostream& it, const Tacka& T) // Pisanje.
    { return it << '(' << T.x << ',' << T.y << ')'; }
};
