// tacka5.h - Klasa pokretnih tačaka.

#ifndef _tacka5_h_
#define _tacka5_h_

#include "pokretan.h"
#include "vektor1.h"
#include "brzina.h"

class Tacka: public Pokretan {
  static inline int pos_id{0};                  // Poslednji identifikator.
  const int id{++pos_id};                       // Identifikator tačke.
  Vektor r;                                     // Vektor položaja.
  Brzina v;                                     // Vektor brzine.
public:
  Tacka(const Vektor& r=Vektor(),               // Nova tačka dobija nov 
        const Brzina& v=Brzina())               //   identifikator.
    : r{r}, v{v} {}
  Tacka(const Tacka& T)                         // Kopija tačke dobija nov
    : r{T.r}, v{T.v} {}                         //   identifikator.
  Tacka& operator=(const Tacka& T)              // Levom operandu se ne
    { r = T.r; v = T.v; return *this; }         //   menja identifikator.
  Tacka& proteklo(double dt) override           // Promena položaja zbog
    { r = r + v * dt; return *this; }           //   proteklog vremena.
  Vektor R() const { return r; }                // Trenutni položaj.
  friend double rastojanje(const Tacka& T1, const Tacka& T2) // Rastojanje
    { return (T2.r + T1.r * -1).intenz(); }                  //   dve tačke
  friend ostream&  operator<<(ostream& it, const Tacka& T)   // Pisanje.
    { return it << 'T' << T.id << T.r; }
};

#endif
