// trougao4.h - Klasa trouglova u ravni.

#ifndef _trougao4_h_
#define _trougao4_h_

#include "figura1.h"
#include <cmath>
using std::sqrt;

class Trougao: public Figura {
  Real a, b, c;                                      // Stranice trougla.
public:                                              // Stvaranje trougla:
  Trougao(Real a=1, const Tacka& t=ORG)              // - jednakostraničnog,
    : Figura{t}, a{a}, b{a}, c{a} {}
  Trougao(Real a, Real b, const Tacka& t=ORG)        // - jednakokrakog,
    : Figura{t}, a{a}, b{b}, c{b} {}
  Trougao(Real a, Real b, Real c, const Tacka& t=ORG)// - opšteg.
    : Figura{t}, a{a}, b{b}, c{c} {}
  Real O() const override { return a + b + c; }      // Obim trougla.
  Real P() const override                            // Površina troug.
    { Real s = (a + b + c) / 2; return sqrt(s*(s-a)*(s-b)*(s-c)); }
  Trougao* kopija() const override                   // Kopija trougla.
    { return new Trougao(*this); }
 private:
  void citaj(istream& ut) override                   // Čitanje troug.
    { Figura::citaj(ut); ut >> a >> b >> c; }
  void pisi (ostream& it) const override {           // Pisanje troug.
    it << "trougao ["; Figura::pisi(it);
    it << ", a=" << a << ", b=" << b   << ", c=" << c
       << ", O=" << O() << ", P=" << P() << ']';
  }
};

#endif
