// uredjaj.h - Klasa električnih uređaja.

#ifndef _uredjaj_h_
#define _uredjaj_h_

#include "potrosac1.h"
#include <string>
#include <utility>
using std::string, std::move;

namespace Potrosaci {
  class Uredjaj: public Potrosac {
    string naz;                                    // Naziv uređaja.
    double sna;                                    // Snaga uređaja.
    void pisi(ostream&it) const override           // Pisanje uređaja.
      { it << naz << '(' << sna << ')'; }
  public:
    Uredjaj(string n, double s): naz{n}, sna{s} {} // Inicijalizacija.
    double snaga() const override { return sna; }  // Snaga uređaja.
    Uredjaj* kopija() const& override    // Kopija potrošača kopiranjem.
      {return new Uredjaj(*this);}
    Uredjaj* kopija() && override        // Kopija potrošača premeštanjem.
      {return new Uredjaj(move(*this));}
  }; // class Uredjaj
} // namespace Potrosaci

#endif
