// vagon.h - Klasa vagona.

#ifndef _vagon_h_
#define _vagon_h_

#include "vozilo4.h"
#include "niz6.h"
#include "pokaz.h"
#include "teret.h"

using P_teret = Pokaz<Teret>; // Tip pametnog pokazivača na vozila.

class Vagon: public Vozilo {
  Niz<P_teret> tereti;                              // Niz tereta.
  void pisi(ostream& it) const override;            // Pisanje vagona.
public:
  Vagon(double st, size_t k): Vozilo(st), tereti(k) {} // Stvaranje.
  Vagon& operator+=(P_teret t)                      // Dodavanje tereta.
    { tereti += t; return *this; }
  double uk_tezina() const override;                // Ukupna težina vagona.
  double vucna_sila() const override { return 0; }  // Vučna sila.
};

#endif
