// voz2.h - Klasa vozova.

#ifndef _voz2_h_
#define _voz2_h_

#include "niz6.h"
#include "pokaz.h"
#include "vozilo4.h"
#include <iostream>
using std::ostream, std::endl;

class G_preopt {};             // KLASA GREŠAKA: Voz je preopterećen.
inline ostream& operator<<(ostream& it, const G_preopt&)
  { return it << "*** Voz je preopterecen! ***"; }

using P_vozilo = Pokaz<Vozilo>; // Tip pametnog pokazivača na vozila.

class Voz {                             // KLASA VOZOVA:
  Niz<P_vozilo> vozila;                 // Niz vozila.
public:
  explicit Voz(size_t k): vozila(k) {}  // Stvaranje praznog voza.
  Voz(const Voz&) =delete;              // Ne sme da se kopira.
  Voz& operator=(const Voz&) =delete;   // Ne sme da se dodeljuje.
  size_t duzina() const                 // Dužina voza.
    { return vozila.duzina(); }
  bool preopt(P_vozilo v) const;        // Da li bi se preopteretio?
  Voz& operator+=(P_vozilo v) {         // Dodavanje vozila.
    if (preopt(v)) throw G_preopt();
    vozila += v;
    return *this;
  }
  friend ostream& operator<<(ostream& it, const Voz& v); // Pisanje voza.
};

#endif
