// voznja.h - Klasa vožnji.

#ifndef _voznja_h_
#define _voznja_h_

#include "niz5.h"
#include "etapa.h"
#include <iostream>
using std::ostream;

class Voznja {
  Niz<Etapa> etape;                          // Niz etapa vožnje.
public:
  explicit Voznja(int kap=10): etape{kap} {} // Stvaranje prazne vožnje.
  Voznja& operator+=(const Etapa& e){        // Dodavanje etape.
    etape += e;
    return *this;
  }
  float duzina() const;                      // Dužina vožnje.
  float trajanje() const;                    // Vreme vožnje.
  float srBrzina() const                     // Srednja brzina vožnje.
    { return duzina() /  trajanje(); }
  friend ostream& operator<<(ostream& it, const Voznja& v) { // Pisanje.
    return it << "(s=" << v.duzina() << ",t=" << v.trajanje()
              << ",v=" << v.srBrzina() << ')';
  }
};

#endif
