// zapis.h – Klasa zapisa o artiklu.

#include <string>
#include <iostream>
using std::string, std::ostream;

class Zapis {
  string naz, jed;                                // Naziv i jedinica mere.
  double kol, cen;                                // Količina i cena.
public:
  Zapis(string n, string j, double c)             // Stvaranje zapisa.
    : naz{n}, jed{j}, kol{0}, cen{c} {}
                                                  // Dohvatanje:
  string naziv() const { return naz; }            // - naziva,
  double kolicina() const { return kol; }         // - količine,
  string jed_mere() const { return jed; }         // - jedinice mere,
  double cena() const { return cen; }             // - cene.
  double vrednost() const { return cen * kol; }   // Izračunavanje vrednosti
  bool operator+=(double dk) {                    // Promena količine.
    if (kol + dk < 0) return false;
    kol += dk; return true;
  }
  friend ostream& operator<<(ostream& it, const Zapis& z) { // Pisanje.
    return it << z.naz << ": " << z.kol << z.jed << " x " 
              << z.cen << "din = " << z.vrednost() << "din"; 
  }
};
